{$A+,B-,D-,E-,F-,I-,L-,N-,O-,R-,S-,V- }

(********************************************************)
(*                GESTION D'UN PORT SERIE               *)
(*                    V1.6   6/04/90                    *)
(*                TURBO 5.5 et TASM 1.0                 *)
(********************************************************)

Unit SerTools;

Interface { ------------ INTERFACE ----------- }
uses Dos;

const

      IRQCOM1   = 4;
      ADRCOM1   = $3F8;

      IRQCOM2   = 3;
      ADRCOM2   = $2F8;

      IRQCOM3   = 4;    { non standard }
      ADRCOM3   = $3E8;

      IRQCOM4   = 3;    { non standard }
      ADRCOM4   = $2E8;

      BD75      = $0600; { VITESSE de communication }
      BD110     = $0417;
      BD300     = $0180;
      BD600     = $00C0;
      BD1200    = $0060;
      BD2400    = $0030;
      BD4800    = $0018;
      BD9600    = $000C;
      BD19200   = $0006;
      BD38400   = $0003;

      NOPARITY  = $00;   { PARAMETRES de communication }
      ODD       = $08;
      EVEN      = $18;
      BITS5     = $00;
      BITS6     = $01;
      BITS7     = $02;
      BITS8     = $03;
      STOP1     = $00;
      STOP2     = $04;

var StLine  : byte;  { etats de la communication }
    StModem : byte;


procedure OpenCom(Irq : byte; Adr : word; vitesse : word; param : byte;
                  LongIn,LongOut : word; ErrOn,MDOn : boolean );
procedure CloseCom;
function  OutEmpty : boolean;
procedure PutCom(Car : char);
procedure ToCom(var point; long : integer);
procedure WriteCom(texte : string);
function  GetCom:char;
function  CharIn: boolean;
procedure ChangeParams(vitesse : word; param : byte);
procedure BrkON;
procedure BrkOFF;
procedure ClearCom;


implementation  (* -------------- INVISIBLE ------------------ *)

var
{
Registres de l'interface serie 8250
}
  IOPUT     : word;         { registre transmission LN_CTL7 = 0     }
  IT_VAL    : word;         { validation des IT     LN_CTL7 = 0     }
  IT_ID     : word;         { identification des IT                 }
  LN_CTL    : word;         { registre de controle de ligne         }
  MD_CTL    : word;         { registre de controle du modem         }
  LN_STAT   : word;         { registre d'etat des lignes            }
  MD_STAT   : word;         { registre d'etat du modem              }


type PtrRec = record
         Ofs,Seg : word;
       end;

const
{
Registres et mot de validation du 8259
}
  CIT       = $20;           { registre de controle des IT           }
  IMR       = $21;           { registre de masque des IT             }
  Valide_It = $20;           { mot de controle pour CIT              }


  LN_CTL7   = $80;           { 7ieme ligne de LN_CTL                 }

{
MD_CTL
}
  DTR       = $01;           { valide data terminal ready            }
  RTS       = $02;           { valide request to send                }
  AUX1      = $04;           { sortie auxiliaire                     }
  AUX2IT    = $08;           { sortie auxiliaire/IT (1 : valide IT)  }
  LOOP      = $10;           { boucle l'UART sur lui-meme            }
{
IT_VAL
}
  VITREC    = $01;           { IT reception validee                  }
  VITSEND   = $02;           { IT emission     "                     }
  VITERR    = $04;           { IT erreur de reception validee        }
  VITMOD    = $08;           { IT changement d'etat du modem         }
{
MD_STAT
}
  MDCD      = $80;           { ligne carrier detect                  }
  MDRING    = $40;           { ligne ring indicator                  }
  MDDSR     = $20;           { ligne data set ready                  }
  MDCTS     = $10;           { ligne clear to send                   }
{
Numero des IT provoquees par l'interface serie
}
  ITMOD     = $00;           { IT etat du modem modifie              }
  ITSEND    = $02;           { IT emission caractere                 }
  ITREC     = $04;           { IT reception caractere                }
  ITERR     = $06;           { IT erreur de reception                }

var
  InSeg   : word; (* segment d'entree *)
  InRead  : word;
  InWrite : word;
  InNb    : word;
  InLg    : word;
  InAdr   : pointer;

  OutSeg  : word;
  OutRead : word;
  OutWrite: word;
  OutNb   : word;
  OutLg   : word;
  OutAdr  : pointer;

  Chainage    : boolean;

  SavePointAux : pointer;
  SaveIntExist : boolean; { indique si l'int (bit) existait deja! }
  PortInt     : byte;        (* reserve *)
  RealEnd     : word;
  NumInt      : byte;

(*$L SERKIT.OBJ *)

procedure it; external;
function CharIn : boolean; external;
function OutEmpty : boolean; external;
function OutReady : boolean; external;
function GetCom : char; external;
procedure PutCom( car : char); external;


procedure CLI; inline($FA);
procedure STI; inline($FB);

procedure AjustAdr(Adr : word);
begin
  IOPUT   := Adr;         { registre transmission LN_CTL7 = 0     }
  IT_VAL  := Adr+1;       { validation des IT     LN_CTL7 = 0     }
  IT_ID   := Adr+2;       { identification des IT                 }
  LN_CTL  := Adr+3;       { registre de controle de ligne         }
  MD_CTL  := Adr+4;       { registre de controle du modem         }
  LN_STAT := Adr+5;       { registre d'etat des lignes            }
  MD_STAT := Adr+6;       { registre d'etat du modem              }
end;

procedure CleanIT;
var anything : byte;
begin
  CLI;
  anything := Port[IT_ID];
  anything := Port[LN_STAT];
  anything := Port[MD_STAT];
  anything := Port[IOPUT];
  STI;
end;

procedure InitRS(vitesse : word; param : byte);
begin
  CLI;
  Port[LN_CTL]  := (LN_CTL7 or Port[LN_CTL]);
  PortW[IOPUT]  := Vitesse;
  Port[LN_CTL]  := ($1F and param);
  STI;
end;

procedure BrkON;
begin
  CLI;
  Port[LN_CTL] := (Port[LN_CTL] and 127) or 64; (* bit BRK allume *)
  STI;
end;

procedure BrkOFF;
begin
  CLI;
  Port[LN_CTL] := (Port[LN_CTL] and $3F); (* bit BRK eteind *)
  STI;
end;

procedure ToCom(var point; long : integer);
var map : array[0..32767] of byte absolute point;
var index : integer;
begin
  for index := 0 to long-1 do PutCom(char(map[index]));
end;

procedure WriteCom(texte : string);
var index : byte;
begin
  for index := 1 to length(texte) do PutCom(texte[index]);
end;

procedure InitVarBuf;
begin
  CLI;
  InRead := 0; InWrite := 0; InNb := 0;
  OutRead := 0; OutWrite := 0; OutNb := 0;
  Chainage := false;
  STI;
end;

procedure ClearCom;
begin
  InitVarBuf;
  CleanIT; CleanIT;
end;

procedure ChangeParams(vitesse : word; param : byte);
begin
  ClearCom;
  InitRS(vitesse,param);
end;

const AddOnLg = 16;

var ComOpen : boolean;
    SaveExitProc : pointer;

procedure OpenCom(Irq : byte; Adr : word; vitesse : word; param : byte;
                  LongIn,LongOut : word; ErrOn,MDOn : boolean );
var msk : byte;
begin
  InLg  := LongIn;
  OutLg := LongOut;
  AjustAdr(Adr);
  msk := 0;
  if InLg>0 then
    begin
      GetMem(InAdr,InLg+AddOnLg);
      InSeg := PtrRec(InAdr).Seg+1;
      inc(msk,VITREC);
    end;
  if OutLg>0 then
    begin
      GetMem(OutAdr,OutLg+AddOnLg);
      OutSeg := PtrRec(OutAdr).Seg+1;
      inc(msk,VITSEND);
    end;
  if ErrOn then inc(msk,VITERR);
  if MDOn then inc(msk,VITMOD);
  StLine  := 0;
  StModem := 0;
  ChangeParams(vitesse,param);
  Port[MD_CTL] := AUX2IT+DTR+RTS;

  if msk<>0 then
    begin
      NumInt := Irq+8;
      CLI;
      GetIntVec(NumInt,SavePointAux);
      SetIntVec(NumInt,@IT);
      Port[IT_VAL] := msk;
      msk := (1 shl Irq) xor 255;
      SaveIntExist := (Port[IMR] and (1 shl Irq))=0;
      Port[IMR] := (msk and Port[IMR]);
      STI;
    end
  else
    begin { aucune interruption n'est gere!!! }
      NumInt := 0;
    end;

  CleanIT; CleanIT;
  ComOpen := TRUE;
end;

procedure CloseCom;
begin
  Port[MD_CTL] := $00;
  Port[IT_VAL] := $00;
  CleanIT; CleanIT;

  if NumInt<>0 then
    begin
      CLI;
      if not(SaveIntExist) then
        Port[IMR] := ((1 shl (NumInt-8)) or Port[IMR]);
          { masque l'IT serie, si elle n'exitait pas avant! }
      SetIntVec(NumInt, SavePointAux);
      STI;
      if InLg>0 then FreeMem(InAdr,InLg+AddOnLg);
      if OutLg>0 then FreeMem(OutAdr,OutLg+AddOnLg);
    end;
  ComOpen := FALSE;
end;

{$F+} procedure SerExit; {$F-}
begin
  ExitProc := SaveExitProc;
  if ComOpen then CloseCom;
end;

begin
  ComOpen := FALSE;
  SaveExitProc := ExitProc;
  ExitProc := @SerExit;
end.
