(*$DEFINE NODEBUG *) (* DEBUG/NODEBUG *)

{$IFDEF VER40 }

(*$IFDEF DEBUG *)
  {$R-,S+,I+,D+,T-,F-,V+,B-,N-,L+ }
  {$M 16384,0,655360 }
(*$ELSE *)
  {$R-,S-,I-,D-,T-,F-,V-,B-,N-,L+ }
  {$M 16384,0,655360 }
(*$ENDIF *)

{$ELSE }

{$A-,B-,D+,E-,F-,I-,L+,N-,O-,R-,S-,V- }
{$M 16384,0,655360 }

{$ENDIF }

program screen;

uses Dos,Crt,SerTools,Stringer,Video2,Error;

const SOFTNAME  = 'TERMINAL';
      VERSION   = 'V1.42 B';
      DATEVER   = '13/09/89';
      AUTEUR    = 'T.JAOUEN';
      COPYRIGHT = 'LOGICOS';

(*******************************************************)
(*                                                     *)
(*                        PARAM                        *)
(*                                                     *)
(*******************************************************)

type TypeParam = string[12];
     CFG_map  = record
                  BAUD    : word;
                  DATA    : byte;
                  STOP    : byte;
                  PARITE  : byte;
                  IRQ     : byte;
                  ADR     : word;
                  LgIN    : word;
                  LgOUT   : word;
                  NEIGE   : boolean;
                  DPath   : word;
                  DPack   : word
                end;

const CFG      : CFG_map = (
                  BAUD   : BD9600;
                  DATA   : BITS7;
                  STOP   : STOP2;
                  PARITE : EVEN;
                  IRQ    : 4;
                  ADR    : $3F8;
                  LgIN   : 1024;
                  LgOUT  : 0;
                  NEIGE  : FALSE;
                  DPath  : 2000; (* 2 secondes *)
                  DPack  : 500 (* 1/2 sec *)
                    );
      CFGFileName = 'TERMINAL.CFG';
      NbreParam = 18;
      ParamTab : array[1..NbreParam] of TypeParam =
                   ('BAUD','DATA','STOP','PARITE',
                    'COM1','COM2','LGIN','LGOUT',
                    'VER',
                    'IRQ3','IRQ4','ADR3F8','ADR2F8','ADR',
                    'NEIGE','PASNEIGE',
                    'DPATH','DPACK' );

procedure Hex(texte : string; var nb : word; var code : integer);
var val : word;
    index : byte;
begin
  val  := 0;
  for index := 1 to length(texte) do
    if texte[index] in ['0'..'9'] then
      val := (val*16)+(byte(texte[index])-48)
    else
      if texte[index] in ['A'..'F'] then
        val := (val*16)+(byte(texte[index])-55)
      else
        begin
          code := index;
          exit;
        end;
  code := 0;
  nb := val;
end;

function TradNumber(texte : string; var nb : word) : boolean;
var code : integer;
    save : word;
begin
  if texte<>'' then
    if texte[1]='$' then Hex(copy(texte,2,length(texte)-1),nb,code)
    else
      begin
        save := nb;
        Val(texte,nb,code);
        if code<>0 then nb := save;
      end;
  TradNumber := (code=0);
end;

procedure GestParam;
var ParamLine : string;
  procedure ChargeParam;
  var fichier : file of byte;
      io : word;
      index : byte;
      colector : byte;
  begin
    ParamLine := '';
    assign(fichier,CFGFileName);
    (*$I-*)
    reset(fichier);
    io := ioresult;
    if io=0 then
      begin
        index := 1;
        while not(eof(fichier)) and (index<256) and (io=0) do
          begin
            read(fichier,colector);
            io := ioresult;
            if colector<48 then colector := byte('/');
            ParamLine := ParamLine+char(colector);
          end;
        if (io=0) then close(fichier);
      end;
    if (io<>2) and (io<>0) then
      begin
        writeln('Erreur lors du chargement du fichier '+CFGFileName);
        writeln('Erreur: ',MsgError(io));
        halt(1);
      end;
    (*$IFDEF DEBUG *) (*$I+*) (*$ENDIF *)
  end;

var index : byte;
    code  : integer;
    CurrentParam : string;
    SecondStr : string;
    Good : boolean;
    ForceEnd : boolean;
    tempo : word;
begin
  ParamLine := '';
  ChargeParam;
  ParamLine := ParamLine+' ';
  for index := 1 to ParamCount do
    ParamLine := ParamLine+ParamStr(index)+' ';
  ForceEnd := false;
  repeat
    index := 1;
    while(index<=length(ParamLine)) and
         not(ParamLine[index] in [' ','+',',','/']) do Inc(index);
    CurrentParam := copy(ParamLine,1,index-1);
    ParamLine := copy(ParamLine,index+1,length(ParamLine)-index);
    KillData(CurrentParam,32);
    UpCaseStr(CurrentParam);
    index := Pos('=',CurrentParam);
    if index<>0 then
      begin
        SecondStr := copy(CurrentParam,index+1,length(CurrentParam)-index);
        CurrentParam := copy(CurrentParam,1,index-1);
      end
    else
      SecondStr := '';
    Good := false;
    for index := 1 to NbreParam do
      if CurrentParam = ParamTab[index] then
        begin
          Good := true;
          case index of
            1 : begin (* BAUD=... *)
                  Good := TradNumber(SecondStr,tempo);
                  if Good then
                    if (115200 mod tempo)=0 then
                      CFG.BAUD := 115200 div tempo
                    else Good := false;
                end;
            2 : begin (* DATA=... *)
                  Good := TradNumber(SecondStr,tempo);
                  if Good then
                    case tempo of
                      5 : CFG.DATA := BITS5;
                      6 : CFG.DATA := BITS6;
                      7 : CFG.DATA := BITS7;
                      8 : CFG.DATA := BITS8;
                    else Good := false;
                    end;
                end;
            3 : begin (* STOP=... *)
                  Good := TradNumber(SecondStr,tempo);
                  if Good then
                    case tempo of
                      1 : CFG.STOP := STOP1;
                      2 : CFG.STOP := STOP2;
                    else Good := false;
                    end;
                end;
            4 : begin (* PARITE=... *)
                  Good := TradNumber(SecondStr,tempo);
                  if Good then
                    case tempo of
                      0 : CFG.PARITE := NOPARITY;
                      1 : CFG.PARITE := ODD;
                      2 : CFG.PARITE := EVEN;
                    else Good := false;
                    end;
                end;
            5 : begin (* COM1 *)
                  CFG.Irq := 4;
                  CFG.Adr := $3F8;
                end;
            6 : begin (* COM2 *)
                  CFG.Irq := 3;
                  CFG.Adr := $2F8;
                end;
            7 : begin (* LGIN= *)
                  Good := TradNumber(SecondStr,CFG.LgIn);
                end;
            8 : begin (* LGOUT= *)
                  Good := TradNumber(SecondStr,CFG.LgOut);
                end;
            9 : begin (* VER *)
                  writeln(SOFTNAME,' ',VERSION,' ',DATEVER);
                  writeln('par ',AUTEUR,'  copyright ',COPYRIGHT);
                  ForceEnd := true;
                end;
            10 : CFG.Irq := 3; (* IRQ3 *)
            11 : CFG.Irq := 4; (* IRQ4 *)
            12 : CFG.Adr := $3F8; (* ADR3F8 *)
            13 : CFG.Adr := $2F8; (* ADR2F8 *)
            14 : Good := TradNumber(SecondStr,CFG.Adr); (* ADR= *)
            15 : CFG.NEIGE := TRUE; (* NEIGE *)
            16 : CFG.NEIGE := FALSE; (* PASNEIGE *)
            17 : Good := TradNumber(SecondStr,CFG.DPath); (* DPath= *)
            18 : Good := TradNumber(SecondStr,CFG.DPack); (* DPack= *)
          end; (* case of *)
        end;
    if not(Good) and (CurrentParam<>'') then
      begin
        write('paramtre incorrecte -> ''',CurrentParam);
        if SecondStr<>'' then write('=',SecondStr);
        writeln('''');
        ForceEnd := true;
      end;
  until ParamLine='';
  if ForceEnd then halt(0);
end;

(*******************************************************)
(*                                                     *)
(*                      LE SOFT                        *)
(*                                                     *)
(*******************************************************)

const
     CNorm     = LIGHTCYAN;
     CBrillant = YELLOW;
     ZnScr     : Zn_Rec = (X:0; Y:0; Lg:80; Ht:24);
var
   Xcur,Ycur  : shortint;
   AttCur     : byte;
   Aig        : byte;
   Param1,Param2,Param3 : LongInt;

procedure BEEP;
begin
  Sound(700);
  Delay(25);
  NoSound;
end;

function ConvVal(valeur : LongInt; LenStr : byte) : string;
var texte : string;
begin
  Str(valeur,texte);
  if length(texte)>LenStr then texte[0] := char(LenStr)
  else
    while length(texte)<LenStr do texte := '0'+texte;
  ConvVal := texte;
end;


(******************** GETING KEY ****************)

procedure ViewKey(var Key : char; var Funct : boolean);
begin
  if keypressed then
    begin
      key := ReadKey;
      if key=#0 then
        begin
          key := ReadKey;
          Funct := true;
        end
      else
        Funct := false;
    end
  else Key := #0;
end;

procedure WaitKey;
var Key : char;
    Funct : boolean;
begin
  repeat
    ViewKey(Key,Funct);
  until Key<>#0;
end;

procedure WriteMsg(msg : string);
begin
  Tronque(msg,71);
  WrtScr(msg+FillString(71-length(msg),32),0,24,YELLOW+RED*16);
end;

procedure RestoreStandMsg;
begin
  WriteMsg(' S I A A P / S E M E R U    EMULATION PC/PS   BULL          ');
end;

function FGetCom : char;
var car : char;
begin
  repeat
    car := GetCom;
  until car<>#127; (* filtre 127 *)
  FGetCom := car;
end;

{*****************Gestion d'envoi d'un fichier*******************}
(*$I- *) (* pas d'erreur io *)

procedure GestSendFile;
const MxLgEnreg = 2000;
var fichier   : file of char;
    Enreg     : array[1..MxLgEnreg] of Char;
    LgEnreg   : word;
    NumPaquet : word;
    LastCode  : char;
  procedure SendNo;
  begin
    WriteCom('N'#13);
  end;

  procedure SendPaquet;
  var Car : char;
      CodeFinal : byte;
      Index : word;
  begin
    Inc(NumPaquet);
    WriteMsg('Envoi de paquet n '+ConvVal(NumPaquet,6));
    Delay(CFG.DPack);
    WriteCom(ConvVal(LgEnreg,4));
    CodeFinal := 0;
    for Index := 1 to LgEnreg do
      begin
        PutCom(Enreg[Index]);
        CodeFinal := CodeFinal+byte(Enreg[Index]);
      end;
    WriteCom(ConvVal(CodeFinal,2));
    PutCom(#13);
  end;

  procedure GetEnreg;
    procedure PutInEnreg(car : char);
    begin
      if LgEnreg<MxLgEnreg then
        begin
          Inc(LgEnreg);
          Enreg[LgEnreg] := car;
        end; (* sinon, on ignore *)
    end;
    function LastEoln(car : char) : boolean;
    (* verifie que car et LastCode ne forme pas une combinaison *)
    (* de fin de ligne... du genre 10+13 ou 13+10               *)
    (* comme la fin de ligne est soit 10 ,soit 13, la combinaison *)
    (* doit etre ignor , car dja trait!! ... *)
    (* par contre, 10+10 (ou 13+13) -> 2 fin de ligne dont une vide... *)
    begin
      LastEoln := ((car=#13) and (LastCode=#10)) or
                  ((car=#10) and (LastCode=#13));
    end;
  var car       : char;
      CodeError : integer;
      EndBoucle : boolean;
  begin
    LgEnreg := 0;
    if not(eof(fichier)) then
      begin
        EndBoucle := false;
        while not(eof(fichier)) and not(EndBoucle) do
          begin
            read(fichier,car);
            CodeError := IoResult;
            if CodeError<>0 then
              begin
                EndBoucle := true;
                LgEnreg := 0; (* on arrette tout! a cause de l'erreur! *)
              end
            else
              if (car in [#10,#13]) then
                if LastEoLn(car) then car := #0 (* pour LastCode *)
                else
                  begin
                    (* fin de ligne *)
                    if LgEnreg=0 then PutInEnreg(#32);
                      (* afin que la ligne ne soit pas vide !! *)
                    EndBoucle := true;
                  end
              else
                if car=#26 then EndBoucle := true (* fin du fichier texte *)
                else PutInEnreg(car);
            LastCode := car;
          end;
      end;
  end;

var Index : byte;
    SmallBuf : string[4];
    CodeError : integer;
    LgFilePath : word;
    FilePath : string;
    EndBoucle : boolean;
begin
  (* saisie de longueur du nom de fichier *)
  WriteMsg('Procedure de transfert en cours ...');
  for Index := 1 to 4 do SmallBuf[Index] := FGetCom;
  SmallBuf[0] := #04;
  val(SmallBuf,LgFilePath,CodeError);
  FilePath := '';
  Delay(CFG.DPath);
  if (LgFilePath <= SizeOf(FilePath)-1) and (LgFilePath>0) and (CodeError=0) then
    begin
      for Index := 1 to LgFilePath do FilePath[Index] := FGetCom;
      FilePath[0] := char(LgFilePath);
      assign(fichier,FilePath);
      reset(fichier);
      CodeError := ioResult;
      if CodeError=0 then
        begin
          WriteCom('O'#13);
          EndBoucle := False;
          LgEnreg := 0;
          NumPaquet := 0;
          LastCode := #0;
          repeat
            case FGetCom of
              'O' : begin
                      GetEnreg;
                      SendPaquet;
                    end;
              'R' : SendPaquet;
              'F' : EndBoucle := True;
            end;
          until EndBoucle;
          Close(fichier);
          CodeError := ioresult;
        end
      else SendNo;
    end
  else SendNo;
  RestoreStandMsg;
end;

(*$IFDEF DEBUG *) (*I+ *) (*$ENDIF *)

{*****************Gestion de reception d'un fichier*******************}
(*$I- *) (* pas d'erreur io *)

procedure GestGetFile;
const MxLgEnreg = 2000;
var fichier   : file of char;
    Enreg     : array[1..MxLgEnreg] of Char;
    LgEnreg   : word;
    NumPaquet : word;
    LastCode  : char;
  procedure SendNo;
  begin
    WriteCom('N'#13);
  end;

  procedure GetPaquet;
  var CodeError : word;
      Index : word;
      Smallbuf : string[4];
  begin
    Inc(NumPaquet);
    WriteMsg('Rception du paquet n '+ConvVal(NumPaquet,6));
    Delay(CFG.DPack);
    for Index := 1 to 4 do SmallBuf[index] := FGetCom;
    SmallBuf[0] := #04;
(*    WriteMsg('Recu:'+SmallBuf);
    WaitKey;  *)
    val(SmallBuf,LgEnreg,CodeError);
    if CodeError<>0 then LgEnreg := 0;
    if LgEnreg>0 then
      begin
        for Index := 1 to LgEnreg do Enreg[Index] := FGetCom;
        Inc(LgEnreg);
        Enreg[LgEnreg] := #13;
        Inc(LgEnreg);
        Enreg[LgEnreg] := #10;
      end;
  end;

  function SavePaquet : boolean;
  var CodeError : integer;
      Index : word;
  begin
    if LgEnreg=0 then SavePaquet := False
    else
      begin
        Index := 1;
        CodeError := 0;
        if LgEnreg=0 then
          begin
            SavePaquet := false;
            exit; (* fin du fichier *)
          end;
        while (index<=LgEnreg) and (CodeError=0) do
          begin
            write(fichier,Enreg[Index]);
            CodeError := IoResult;
            Inc(Index);
          end;
        SavePaquet := (CodeError=0);
      end;
  end;

const EndOfFile : char = #26;
var Index : byte;
    SmallBuf : string[4];
    CodeError : integer;
    LgFilePath : word;
    FilePath : string;
begin
  (* saisie de longueur du nom de fichier *)
  WriteMsg('Procedure de transfert en cours ...');
  for Index := 1 to 4 do SmallBuf[Index] := FGetCom;
  SmallBuf[0] := #04;
  val(SmallBuf,LgFilePath,CodeError);
  FilePath := '';
  Delay(CFG.DPath);
  if (LgFilePath <= SizeOf(FilePath)-1) and (LgFilePath>0) and (CodeError=0) then
    begin
      for Index := 1 to LgFilePath do FilePath[Index] := FGetCom;
      FilePath[0] := char(LgFilePath);
      assign(fichier,FilePath);
      rewrite(fichier);
      CodeError := ioResult;
      if CodeError=0 then
        begin
          WriteCom('O'#13);
          LgEnreg := 0;
          NumPaquet := 0;
          repeat
            GetPaquet;
          until not(SavePaquet);
          write(fichier,EndOfFile); (* marque de fin de fichier texte *)
          Close(fichier);
          CodeError := ioresult;
        end
      else SendNo;
    end
  else SendNo;
  RestoreStandMsg;
end;

(*$IFDEF DEBUG *) (*I+ *) (*$ENDIF *)

procedure AffSitCurseur;
begin
  WrtScr(' L'+ConvVal(Ycur+1,2)+' C'+ConvVal(Xcur+1,2)+' ',71,24,BLACK+CYAN*16);
end;

procedure CurChange;
begin
  AffSitCurseur;
  if Xcur<80 then CurXY(Xcur,Ycur);
end;

procedure ClrScr;
begin
  AttCur := CNorm;
  ZnUp(ZnScr,0,AttCur);
  Xcur := 0;
  Ycur := 0;
  CurChange;
end;

procedure LineFeed;
begin
  Inc(Ycur);
  if Ycur>23 then
    begin
      Ycur := 23;
      ZnUp(ZnScr,1,AttCur);
    end;
  if Xcur>79 then Xcur := 0;
  CurChange;
end;

procedure ClrEol;
var Zn : Zn_Rec;
begin
  if Xcur<80 then
    begin
      Zn.X := Xcur;
      Zn.Y := Ycur;
      Zn.Lg := 80-Xcur;
      Zn.Ht := 1;
      ZnUp(Zn,0,AttCur);
    end;
end;

procedure ClrEof;
var Zn : Zn_Rec;
begin
  ClrEol;
  if Ycur<23 then
    begin
      Zn.X := 0;
      Zn.Y := Ycur+1;
      Zn.Lg := 80;
      Zn.Ht := 23-Ycur;
      ZnUp(Zn,0,AttCur);
    end;
end;

procedure InsertLine;
var Zn : Zn_Rec;
begin
  Zn.X := 0;
  Zn.Y := Ycur;
  Zn.Lg := 80;
  Zn.Ht := 24-Ycur;
  ZnDn(Zn,1,AttCur);
end;

procedure DeleteLine;
var Zn : Zn_Rec;
begin
  Zn.X := 0;
  Zn.Y := Ycur;
  Zn.Lg := 80;
  Zn.Ht := 24-Ycur;
  ZnUp(Zn,1,AttCur);
end;

procedure GestCar( data : byte);
begin
  if (Xcur>79) then LineFeed;
  WrtDt(data,Xcur,Ycur,AttCur);
  Inc(Xcur);
  CurChange;
end;

procedure RectifXY;
begin
  if Xcur>79 then Xcur := 79
  else
    if Xcur<0 then Xcur := 0;
  if Ycur>23 then Ycur := 23
  else
    if Ycur<0 then Ycur := 0;
end;

procedure DeleteCol;
begin
  if Xcur<80 then
    begin
    end;
end;

procedure InsertCol;
begin
  if Xcur<80 then
    begin
    end;
end;

procedure Emul(data : byte);
const Trad : array[1..11] of char = (
               '','','','','','','','','','','' );
begin
  if (data=0) then exit;
  if (data>=127) then
    begin
      Aig := 0;
      exit;
    end;
  if data<32 then
    begin (* code de commandement *)
      Aig := 0; (* tout aiguillage en cours est annulle *)
  case data of
    07 : BEEP; (* BEL *)
    08 : begin (* back space *)
           Dec(Xcur);
           if Xcur<0 then Xcur := 0;
           CurChange;
         end;
    10 : LineFeed; (* line feed *)
    12 : ClrScr; (* efface ecran *)
    13 : begin (* retour chariot *)
           Xcur := 0;
           CurChange;
         end;
    $10..$1A : GestCar(byte(Trad[data-$0F])); (* car speciaux *)
    27 : Aig := 1; (* need more information *)
  end; (* case of *)
    end
  else
    begin (* argument ou car *)
      case Aig of
        0 : GestCar(data);
        1 : begin (* ESC data [,X,Y,...] *)
              case data of
                $4A : ClrEof; (* del end of file *)
                $33 : AttCur := CBrillant; (* surbrillance *)
                $34 : AttCur := CNorm; (* normal *)
                $6E : (* pos. cur *)
                      WriteCom(#27#$66+char(Xcur+32)+char(Ycur+32));
                $60 : ClrScr; (* efface ecran *)
                $48 : begin (* cur home *)
                        Xcur := 0;
                        Ycur := 0;
                        CurChange;
                      end;
                $4B : begin (* del end of line *)
                        ClrEol;
                      end;
                $42 : begin (* ligne en dessous *)
                        Inc(Ycur);
                        if Ycur>23 then Ycur := 0;
                        CurChange;
                      end;
                $41 : begin (* ligne au dessus *)
                        Dec(Ycur);
                        if Ycur<0 then Ycur := 23;
                        CurChange;
                      end;
                $43 : begin (* col a droite *)
                        Inc(Xcur);
                        if Xcur>79 then Xcur := 0;
                        CurChange;
                      end;
                $44 : begin (* col a gauche *)
                        Dec(Xcur);
                        if Xcur<0 then Xcur := 79;
                        CurChange;
                      end;
                $4C : InsertLine; (* insertion d'une ligne *)
                $4D : DeleteLine; (* suppression d'une ligne *)
                $50 : DeleteCol; (* suppression d'une col *)
                $40 : InsertCol; (* insertion d'une col *)
                $66 : begin
                        Aig := 2;
                        Param1 := 0;
                      end;
                $20 : GestSendFile;
                $21 : GestGetFile;
              end; (* case of *)
              if Aig=1 then Aig := 0;
            end;
        2 : begin (* ESC $66 X,Y *)
              if Param1=0 then
                begin
                  Param2 := data;
                  Inc(Param1);
                end
              else
                begin
                  Xcur := Param2-32;
                  Ycur := data-32;
                  RectifXY;
                  CurChange;
                  Aig := 0;
                end;
            end;
      end; (* case Aig of *)
    end;
end;

function DitOui(msg : string) : boolean;
var Key : char;
    Funct,EndBoucle : boolean;
    Rep : boolean;
begin
  msg := msg+' (O/N) ';
  WriteMsg(msg);
  WrtDt(219,length(msg),24,128+YELLOW+RED*16);
  EndBoucle := false;
  repeat
    while CharIn do Emul(byte(GetCom));
    ViewKey(Key,Funct);
    Key := UpCase(Key);
    if Key<>#0 then
      if not(Funct) then
        case Key of
          'O' : begin
                  Rep := True;
                  EndBoucle := True;
                end;
          'N' : begin
                  Rep := False;
                  EndBoucle := true;
                end;
        else BEEP;
        end
      else BEEP;
  until EndBoucle;
  RestoreStandMsg;
  DitOui := Rep;
end;

procedure InitSoft;
begin
  (*$IFNDEF DEBUG *)
  CheckBreak := FALSE;
  (*$ENDIF *)
  OpenVideoSys(VMODE_UNDEF,CFG.NEIGE); (* neige *)
  CurFormat(0,7);
  RestoreStandMsg;
  Aig  := 0;
  ClrScr;
  OpenCom(CFG.IRQ,CFG.ADR,CFG.BAUD,CFG.PARITE+CFG.STOP+CFG.DATA,
          CFG.LgIn,CFG.LgOut,false,false);
end;

procedure EndSoft;
begin
  CloseCom;
  CloseVideoSys;
  halt(0);
end;

procedure AnalyseKey(Key : char; Funct : boolean);
begin
  if Key<>#0 then
    if Funct then (* Touche de fonction a analyser *)
      case Key of
        #59 : WriteCom(#27#$30); (* F1  *)
        #60 : WriteCom(#27#$32); (* F2  *)
        #61 : WriteCom(#27#$36); (* F3  *)
        #62 : WriteCom(#27#$38); (* F4  *)
        #63 : WriteCom(#27#$3A); (* F5  *)
        #64 : WriteCom(#27#$3C); (* F6  *)
        #65 : WriteCom(#27#$3E); (* F7  *)
                                 (* F8  *)
                                 (* F9  *)
        #68 : WriteCom(#27#$4B); (* F10 *)

        #71 : WriteCom(#27#$48); (* Home *)
        #72 : WriteCom(#27#$41); (* cur haut *)
                                 (* PgUp *)
        #75 : WriteCom(#27#$44); (* cur gauche *)
        #77 : WriteCom(#27#$43); (* cur droit *)
        #79 : WriteCom(#27#$69); (* End *)
        #80 : WriteCom(#27#$42); (* cur bas *)
                                 (* PgDn *)
                                 (* Ins *)
                                 (* Del *)

        #84 : WriteCom(#27#$31); (* Shift F1  *)
        #85 : WriteCom(#27#$35); (* Shift F2  *)
        #86 : WriteCom(#27#$37); (* Shift F3  *)
        #87 : WriteCom(#27#$39); (* Shift F4  *)
        #88 : WriteCom(#27#$3B); (* Shift F5  *)
        #89 : WriteCom(#27#$3D); (* Shift F6  *)
        #90 : WriteCom(#27#$3F); (* Shift F7  *)
                                 (* Shift F8  *)
                                 (* Shift F9  *)
                                 (* Shift F10 *)

        #104 : if DitOui('Quitter '+SOFTNAME+'?') then EndSoft;
        #113 : begin (* ALT+F10 -> Brk sur la ligne *)
                 BrkON;
                 Delay(25);
                 BrkOFF;
               end;
       else BEEP; (* mauvaise touche *)
     end
   else
     begin (* pas une touche de fonction *)
       if Key<=#127 then PutCom(Key)
       else BEEP; (* code depassant 7 bits utiles *)
     end;
end;

{**********************debut du programme**************************}
var Key   : char;
    Funct : boolean;
    EndBoucle : boolean;
begin
  GestParam;
  InitSoft;
  EndBoucle := False;
  while(TRUE) do
    begin
      while CharIn do Emul(byte(GetCom));
      ViewKey(Key,Funct);
      AnalyseKey(Key,Funct);
    end;
end.
